﻿package com.strike.PHPRemoting {
	/* By Josh Strike // josh@joshstrike.com // Use freely and enjoy! */
	import flash.net.NetConnection;
	import flash.events.NetStatusEvent;

	import flash.net.Responder;
	
	import flash.utils.Timer;
	import flash.events.TimerEvent;
	
	public class PHPCall {
		
		public var phpAccessInstance:PHPAccess;
		public var toFunction:Function;
		public var serviceClass:String;
		public var output:String;
		
		private var args:Object;
		
		private var callTimer:Timer;
		
		private var callCompleted:Boolean = false;
				
		public function PHPCall(phpAccessInstance:PHPAccess, toFunction:Function, serviceClass:String, ... args) {
			this.serviceClass = serviceClass;
			this.toFunction = toFunction;
			this.phpAccessInstance = phpAccessInstance;
			this.args = args;
			
			if (phpAccessInstance.lockedExpressions) {
				this.args.unshift(phpAccessInstance.lockedExpressions);
			}

			var callStr:String = this.walk(args);
			
			if (phpAccessInstance.netDebug) {
				this.phpAccessInstance.recordResult("Call", toFunction, serviceClass, callStr);
			}
			
			doCall();
		}
		private function doCall() {
			
			callTimer ? callTimer.reset() : callTimer = new Timer(1000,6);
			callTimer.addEventListener(TimerEvent.TIMER_COMPLETE,this.timedOut,false,0,true);
			callTimer.start();
			
			var rsResponder:Responder = new Responder(convertData, handleError);
			this.phpAccessInstance.rs.addEventListener(NetStatusEvent.NET_STATUS,this.gotStatus,false,0,true);
			var c:Number = 2;
			var callArr:Array = new Array(serviceClass,rsResponder);
			for (var j:* in args) {
				callArr[c] = args[j];
				c++;
			}
			this.phpAccessInstance.rs.call.apply(this, callArr); 
		}
		public function handleError(fe:Object):void {
			
			callTimer.stop();
			callTimer.reset();
			
			callCompleted = true;
			
			if (phpAccessInstance.netDebug) {
				this.phpAccessInstance.recordResult("Error", this.toFunction, this.serviceClass, 
											  String(fe.code+": "+fe.description+"\r in "+fe.details+" LINE "+fe.line));
			}
		}
		public function gotStatus(event:Object):void {
			//trace (event.info.code);
		}
		private function timedOut(evt:TimerEvent):void {
			callTimer.stop();
			callTimer.reset();
			phpAccessInstance.setPending(this);
		}
		public function retry():void {
			!callCompleted ? doCall() : void;
		}
		private function convRec(r:Object):Array {
			var rsArr:Array = new Array();
			var colCount:Number = r.serverInfo.columnNames.length;
			for (var row:Number=0;row<r.serverInfo.initialData.length;row++) {
				rsArr[row] = new Array();
				for (var colIndex:* in r.serverInfo.columnNames) {
					rsArr[row][r.serverInfo.columnNames[colIndex]] = r.serverInfo.initialData[row][colIndex];
				}
			}
			var retArr:Array = new Array(rsArr,this.walk(rsArr));
			return retArr;
		}
		public dynamic function convertData(re:Object):void {

			callTimer.stop();
			callTimer.reset();
			
			phpAccessInstance ? phpAccessInstance.clearPending(this) : void;
			
			callCompleted = true;
			
			var log:String = "";
			var resultType:String;
			if (!re) {
				resultType = "false";
				var outFalse:Boolean = false;
			} else if (re is Number) {
				//integer//
				resultType = "Number";
				var outN:Number = Number(re);
				log += String(re);
			} else if (re is String) {
				resultType = "String";
				var outS:String = String(re);
				log += re;
			} else {
				var outA:Object = new Object();
				if (!("serverInfo" in re)) {
					resultType = "Array";
					outA = re;
					log += this.walk(re);
					for (var i:* in re) {
						if (re[i]) {
							if ("serverInfo" in re[i]) {
								var z:Array = convRec(re[i]);
								re[i] = z[0];
								log += i+" ::: SQL RESULT\r"+z[1];
							}
						}
					}
				} else {
					//parse it as a recordSet//
					resultType = "RecordSet";
					var rsArr:Array = new Array();
					var colCount:Number = re.serverInfo.columnNames.length;
					for (var row:Number=0;row<re.serverInfo.initialData.length;row++) {
						rsArr[row] = new Array();
						for (var colIndex:* in re.serverInfo.columnNames) {
							rsArr[row][re.serverInfo.columnNames[colIndex]] = re.serverInfo.initialData[row][colIndex];
						}
					}
					log += this.walk(rsArr);
					outA = rsArr;
				}
			}
			var endRes:Object = new Object();
			endRes.log = log;
			switch (resultType) {
				case "false": 
					endRes.result = outFalse;
					break;
				case "Number":
					endRes.result = outN;
					break;
				case "String":
					endRes.result = outS;
					break;
				case "Array":
					endRes.result = outA;
					break;
				case "RecordSet":
					endRes.result = outA;
					break;
				default: 
					endRes.result = null;
					break;
			}
			endRes.resultType = resultType;
			
			if (phpAccessInstance.errorFunction != null && resultType == "Array") {
				if (endRes.result.error) {
					if (endRes.result.error != "") {
						//the user-defined errorFunction for this PHPAccess must return true if it successfully handles the error. 
						//Otherwise, this result will continue to be processed to the result stage.
						//This is to allow errors to be received and processed silently, and/or to let one set of errors be globally defined 
						//(e.g. errors arising out of lockedExpressions)
						//and other errors be handled by individual calls.
						if (phpAccessInstance.errorFunction(endRes.result.error)) {
							return (void);
						}
					}
				}
			}
			
			var finale:PHPResult = new PHPResult(endRes,this.toFunction);
			if (phpAccessInstance) {
				if (phpAccessInstance.netDebug) {
					this.phpAccessInstance.recordResult("Result ::: "+resultType+" :::", this.toFunction, this.serviceClass, endRes.log);
					this.phpAccessInstance.rs.removeEventListener(NetStatusEvent.NET_STATUS,this.gotStatus);
					phpAccessInstance = null;
				}
			}
		}
		public function walk(re:Object) {
			var walkOut:String = "";
			if (phpAccessInstance) {
				if (phpAccessInstance.netDebug && phpAccessInstance.resViewer) {
					this.output = "";
					walkOut = this.walkAssoc(re,0);
					this.output = "";
				}
			}
			return walkOut;
		}
		private function walkAssoc(re:Object,depth:Number) {
			var space:String = "   ";
			var spaces:String = "";
			for (var d:Number=0;d<depth;d++) {
				spaces += space;
			}
			for (var c:* in re) {
				if (!(re[c] is String) && !(re[c] is Number) && c != "serverInfo" && depth<4) {
					this.output += spaces+"["+c+"] => \r";
					this.walkAssoc(re[c],depth+1);
				} else if (depth>=4) {
					this.output += "TOO DEEP";
				} else {
					this.output += spaces+"["+c+"] => "+re[c]+"\r";
				}
			}
			return (this.output);
		}
	}
}